create or replace PROCEDURE "PERSONANCESTORBUILD" (level IN number, Person_In IN varchar2, Supervisor_In IN varchar2) AS 
--
-- The procedure is called recursively to build the personancestor table
-- in maximo. Since it does a complete rebuild of the user's entries it assumes the table
-- has been previously truncated, or all the user's heirarchy of records deleted.
--
New_PersonID   varchar2(10);
New_Supervisor varchar2(10);
Supervisor_Check integer := 0;

BEGIN
  If level = null or person_in = null then
    return;
  else
    --
    -- Insert personancestor record for root.
    -- Find person record for supervisor.
    -- Does this new person have a supervisor
    -- If so, call PersonAncestorBuild again with new values.
    -- otherwise return.
    --
    If Level = 0 then
      Insert into personancestor
        (ancestor, personid ,hierarchylevels, personancestorid)
        Values
        (Person_In, person_In, 0, personancestorseq.nextval);
    end if;
    --
    If Supervisor_In is not null then
      --
      -- Make sure supervisor exists before proceeding.
      --
      Select count(*) into Supervisor_Check from person where personid = Supervisor_In;
      --
      If Supervisor_Check > 0 then
        Insert into personancestor
          (ancestor, personid ,hierarchylevels, personancestorid)
        Values
          (Supervisor_In, person_In, level+1, personancestorseq.nextval);
      
        Select personid, supervisor into new_personid, new_supervisor
        from person
        where personid = supervisor_in;
        --
        -- Check to see if we are done with the chain.
        --
        If new_supervisor is null then
          return;
        else
          PersonAncestorBuild(level+1,Person_In, new_supervisor);
        end if;
      else
        null;
        --
        -- No matching person for supervisor reference.
        --
        -- dbms_output.put_line('Person ID: '||Person_In||' supervisor reference is invalid, supervisor ref: '||Supervisor_In);
      end if;
    end if;
  end if;
END PERSONANCESTORBUILD;