create or replace PROCEDURE "PERSONANCESTORCALL" AS 
--
-- This procedure reads through the person table, and when it finds an active person
-- record with a supervisor it then calls the personancestorbuild procedure to build
-- the personancestor records. Note the personancestor table must have been previously
-- turncated or delete as this rebuilds the entire table, so maximo should be down
-- or idle, ie no user activity.
--
Cursor Person_Cursor is
  Select Person.PersonID,
         PersonUID,
         Acct_Locked,
         Supervisor
  from person
  order by personid;
  
Commit_Count number := 0;

PersonVal Person_Cursor%ROWTYPE;

BEGIN
  --
  -- Empty the personancestor table and reset the sequence.
  --
  -- Truncate table PersonAncestor reuse storage;  -- Note this removes all data from the table.
  -- drop sequence PERSONANCESTORSEQ; -- Dropping sequence so you can start over.
  -- CREATE SEQUENCE PERSONANCESTORSEQ INCREMENT BY 1 MAXVALUE 9999999999999999999999999999 MINVALUE 1 CACHE 20; -- adding sequence
  --
  -- Begin processing through the Person table.
  --
  dbms_output.put_line('Starting Time: '||Current_Timestamp);
  Open Person_Cursor;
    Loop
      fetch Person_Cursor into PersonVal;
      exit when Person_Cursor%NOTFOUND;
      personancestorbuild(0,personval.personid,personval.supervisor);
      Commit_Count := Commit_Count + 1;
      If Commit_Count > 1000 then
        commit;
        Commit_Count := 0;
      end if;
    End Loop;
  Close Person_Cursor;
  Commit;
  Update maxsequence set maxreserved = (select max(personancestorid) from personancestor) where tbname = 'PERSONANCESTOR' and name = 'PERSONANCESTORID';
  commit;
  dbms_output.put_line('End Time: '||Current_Timestamp);
END PERSONANCESTORCALL;