create or replace PROCEDURE WOANCESTORCALL AS  
--
-- This procedure reads through the work order table, and when it finds a work order
-- record with a parent it then calls the woancestorbuild procedure to build
-- the woancestor records. It is currently configured to commit after every 5,000 
-- records. Note the woancestor table must be empty because it is rebuilt, 
-- so the application should be idle or Maximo should be down. The last commit
-- should pick up anything under the 5K check.
--
Cursor WorkOrder_Cursor is
  Select WoNum,
         Parent,
         Orgid,
         Siteid
  from workorder
  order by WoNum;
  
Commit_Count number := 0;
  
WorkOrderVal WorkOrder_Cursor%ROWTYPE;

BEGIN
  --
  -- Empty the woancestor table and reset the sequence.
  --
  -- Truncate table WoAncestor reuse storage;  -- Note this removes all data from the table.
  -- drop sequence WOANCESTORSEQ; -- Dropping sequence so you can start over.
  -- CREATE SEQUENCE WOANCESTORSEQ INCREMENT BY 1 MAXVALUE 9999999999999999999999999999 MINVALUE 1 CACHE 20; -- adding sequence
  --
  -- Begin processing through the work orders.
  --
  dbms_output.put_line('Starting Time: '||Current_Timestamp);
  Open WorkOrder_Cursor;
    Loop
      fetch WorkOrder_Cursor into WorkOrderVal;
      exit when WorkOrder_Cursor%NOTFOUND;
      WoAncestorBuild(0,WorkOrderval.WoNum,WorkOrderval.Parent,WorkOrderVal.Orgid,WorkOrderVal.SiteId);
      Commit_Count := Commit_Count + 1;
      If Commit_Count > 5000 then
        Commit;    
        Commit_Count := 0;
      end if;
    End Loop;
  Close WorkOrder_Cursor;
  --
  -- Update Maximo's maxsequence table to match.
  --
  Update maxsequence set maxreserved = (select max(woancestorid) from woancestor) where tbname = 'WOANCESTOR' and name = 'WOANCESTORID';
  commit;
  dbms_output.put_line('Ending Time: '||Current_TimeStamp);

END WOANCESTORCALL;